package net.codinux.banking.client.fints4k

import net.codinux.banking.client.BankingClientCallback
import net.dankito.banking.fints.callback.FinTsClientCallback
import net.dankito.banking.fints.messages.datenelemente.implementierte.tan.TanGeneratorTanMedium
import net.dankito.banking.fints.model.BankData
import net.dankito.banking.fints.model.EnterTanGeneratorAtcResult
import net.dankito.banking.fints.model.TanMethod

open class BridgeFintTsToBankingClientCallback(
    protected val bankingClientCallback: BankingClientCallback,
    protected val mapper: FinTs4kMapper
) : FinTsClientCallback {

    override suspend fun askUserForTanMethod(supportedTanMethods: List<TanMethod>, suggestedTanMethod: TanMethod?): TanMethod? {
        return suggestedTanMethod
    }

    override suspend fun enterTan(tanChallenge: net.dankito.banking.fints.model.TanChallenge) {
        bankingClientCallback.enterTan(mapper.mapTanChallenge(tanChallenge)) { enterTanResult ->
            if (enterTanResult.enteredTan != null) {
                tanChallenge.userEnteredTan(enterTanResult.enteredTan!!)
            } else {
                tanChallenge.userDidNotEnterTan()
            }
        }
    }

    override suspend fun enterTanGeneratorAtc(bank: BankData, tanMedium: TanGeneratorTanMedium): EnterTanGeneratorAtcResult {
        return EnterTanGeneratorAtcResult.userDidNotEnterAtc()
    }
}