package net.codinux.banking.client.fints4k

import net.codinux.banking.client.BankingClient
import net.codinux.banking.client.BankingClientCallback
import net.codinux.banking.client.model.options.GetAccountDataOptions
import net.codinux.banking.client.model.request.GetAccountDataRequest
import net.codinux.banking.client.model.response.GetAccountDataResponse
import net.codinux.banking.client.model.response.Response
import net.dankito.banking.fints.FinTsClient

open class FinTs4kBankingClient(
    callback: BankingClientCallback
) : BankingClient {

    private val mapper = FinTs4kMapper()

    private val client = FinTsClient(BridgeFintTsToBankingClientCallback(callback, mapper))


    override suspend fun getAccountDataAsync(request: GetAccountDataRequest): Response<GetAccountDataResponse> {
        val response = client.getAccountDataAsync(mapper.mapToGetAccountDataParameter(request, request.options ?: GetAccountDataOptions()))

        return mapper.map(response)
    }

}